import { OnInit, EventEmitter, TemplateRef } from '@angular/core';
import { NNInternalTreeNode } from './nn-internal-tree-node';
export declare class NNTreeComponent implements OnInit {
    width: number;
    private selectParent;
    private lazyLoading;
    loadingText: string;
    loadingIcon: string;
    private showRoot;
    private height;
    changeselection: EventEmitter<NNInternalTreeNode>;
    openNode: EventEmitter<NNInternalTreeNode>;
    closeNode: EventEmitter<NNInternalTreeNode>;
    nnTreeItem: TemplateRef<any>;
    nnTreeToogleIcon: TemplateRef<any>;
    private container;
    private renderNodes;
    private displayNodes;
    private orginalNodes;
    private itemHeight;
    private itemsPerViewport;
    private startIndex;
    private actualHeight;
    private selectedNode;
    private filterText;
    private paddingLeft;
    private numDisplayItems;
    private _root;
    private _index;
    constructor();
    ngOnInit(): void;
    root: NNInternalTreeNode;
    private initTreeData(node, level);
    private refresh(force?);
    private onClickToogleIcon(node);
    private onOpenNode(node);
    private onCloseNode(node);
    private onClickItem(node);
    private onDblclickItem(node);
    filter(text: string): void;
    showLoading(node: NNInternalTreeNode): void;
    hideLoading(node: NNInternalTreeNode): void;
    private addRenderedChildren(node, children, noRefresh?);
    private removeRenderedChildren(node);
    addNodeChildren(node: NNInternalTreeNode, children: NNInternalTreeNode[]): void;
    removeNodeChildren(node: NNInternalTreeNode): void;
}
